Index: typo3/sysext/cms/tslib/class.tslib_content.php
===================================================================
--- typo3/sysext/cms/tslib/class.tslib_content.php	(revision 2991)
+++ typo3/sysext/cms/tslib/class.tslib_content.php	(working copy)
@@ -4322,10 +4322,14 @@
 					$stripNL = 0;
 						// in-tag
 					if (!$currentTag && !$tag['out'])	{
-						$currentTag = $tag;		// $currentTag er lig med det tag (array!), man er igang med!
-						$contentAccumP++;
-						$treated=1;
-					}
+						$currentTag=$tag;		// $currentTag (array!) is the tag we are currently processing
+ 						$contentAccumP++;
+ 						$treated=1;
+							// in-out-tag: img and other empty tags
+						if ($tag[0]=='img' || substr($tag[1],-3,2)==' /')	{
+							$tag['out']=1;
+						}
+ 					}
 						// out-tag
 					if ($currentTag[0]==$tag[0] && $tag['out'])	{
 						$theName = $conf['tags.'][$tag[0]];
Index: typo3/sysext/rtehtmlarea/ext_conf_template.txt
===================================================================
--- typo3/sysext/rtehtmlarea/ext_conf_template.txt	(revision 2991)
+++ typo3/sysext/rtehtmlarea/ext_conf_template.txt	(working copy)
@@ -22,28 +22,28 @@
   # cat=basic/enable/02; type=boolean; label=Enable images in the RTE: If set, the use of images will be enabled in the default configuration of the RTE.
 enableImages = 0
 
-  # cat=basic/enable/03; type=boolean; label=Enable links accessibility icons: If set, accessibility icons will be added in front of links.
+  # cat=basic/enable/05; type=boolean; label=Enable links accessibility icons: If set, accessibility icons will be added in front of links.
 enableAccessibilityIcons = 0
 
   # cat=basic/enable/04; type=boolean; label=Enable the DAM media browser: If set and if the DAM extension is installed, the DAM media browser will be used by the Insert image dialog.
 enableDAMBrowser = 0
 
-##  # cat=basic/enable; type=boolean; label=EXPERIMENTAL! Enable click-enlarge on images: This feature is EXPERIMENTAL. If set, a click-enlarge property may be set on images inserted in the RTE.
-##enableClickEnlarge = 0
+  # cat=basic/enable/03; type=boolean; label=Enable click-enlarge on images: If set, a click-enlarge property may be set on images inserted in the RTE.
+enableClickEnlarge = 0
 
-  # cat=basic/enable/05; type=boolean; label=Enable Mozilla/Firefox extension: If set, enables the triggering of installation of a Mozilla/Firefox extension to allow the RTE to access the clipboard.
+  # cat=basic/enable/06; type=boolean; label=Enable Mozilla/Firefox extension: If set, enables the triggering of installation of a Mozilla/Firefox extension to allow the RTE to access the clipboard.
 enableMozillaExtension = 0
 
-  # cat=basic/enable/09; type=boolean; label=Enable the RTE in Opera 9: If set, the RTE will be enabled when the browser is Opera 9.
+  # cat=basic/enable/08; type=boolean; label=Enable the RTE in Opera 9: If set, the RTE will be enabled when the browser is Opera 9.
 enableInOpera9 = 0
 
-  # cat=basic/enable/06; type=boolean; label=Force Aspell command mode: If set, the spellchecker will use the Aspell command interface. Presumably. PHP is compiled with pspell, but with an old version of Aspell. If set, PHP safe mode should NOT be enabled.
+  # cat=basic/enable/07; type=boolean; label=Force Aspell command mode: If set, the spellchecker will use the Aspell command interface. Presumably. PHP is compiled with pspell, but with an old version of Aspell. If set, PHP safe mode should NOT be enabled.
 forceCommandMode = 0
 
-  # cat=basic/enable/08; type=boolean; label=Enable troubleshooting mode: If set, a troubleshooting log will be displayed below the editing area.
+  # cat=basic/enable/10; type=boolean; label=Enable troubleshooting mode: If set, a troubleshooting log will be displayed below the editing area.
 enableDebugMode = 0
 
-  # cat=basic/enable/07; type=boolean; label=Enable compressed scripts: If set, the compressed version of the editor scripts will be used.
+  # cat=basic/enable/09; type=boolean; label=Enable compressed scripts: If set, the compressed version of the editor scripts will be used.
 enableCompressedScripts = 1
 
   # cat=basic; type=string; label=Url of AllowClipboard Helper: Full absolute Url of the AllowClipboard Helper extension for Mozilla and Firefox.